seo:
  title: 'Pipelines-as-Code: How to improve speed from idea to production'
  description: >-
    Pipelines-as-Code streamline automatic building, testing, and deploying of
    applications using prebuilt pipelines and infrastructure components. Here's
    how it works.
  ogTitle: 'Pipelines-as-Code: How to improve speed from idea to production'
  ogDescription: >-
    Pipelines-as-Code streamline automatic building, testing, and deploying of
    applications using prebuilt pipelines and infrastructure components. Here's
    how it works.
  noIndex: false
  ogImage: images/blog/hero-images/logoforblogpost.jpg
  ogUrl: https://about.gitlab.com/blog/pipelines-as-code
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/pipelines-as-code
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "Pipelines-as-Code: How to improve speed from idea to production",
            "author": [{"@type":"Person","name":"Robert Williams"}],
            "datePublished": "2022-01-18",
          }

content:
  title: 'Pipelines-as-Code: How to improve speed from idea to production'
  description: >-
    Pipelines-as-Code streamline automatic building, testing, and deploying of
    applications using prebuilt pipelines and infrastructure components. Here's
    how it works.
  authors:
    - Robert Williams
  heroImage: images/blog/hero-images/logoforblogpost.jpg
  date: '2022-01-18'
  body: >

    Today’s DevOps platform-centric world is moving steadily towards an
    "Everything-as-Code" mentality. Add in cloud native, and it's clearly even
    more important to standardize how you define your DevOps processes.


    ## Why ‘as-Code’?


    Thanks to faster iteration, cloud native computing, and [microservices-based
    architectures]

    (https://about.gitlab.com/topics/microservices/), as-Code technologies have
    become the de-facto standard for a lot of different parts of the software
    development lifecycle. 


    The need to release faster requires a single spot for teams to collaborate
    on any kind of change – code, infrastructure, configuration, networking, or
    testing. And to implement that change quickly we need to be able to see and
    review it before it goes into production. 


    As-Code solutions are at the core of cloud native technologies such as
    Kubernetes, where you utilize YAML or JSON formats to configure and manage.
    Here are the key advantages of 'as-Code':


    - auditability

    - scalability

    - efficiency

    - collaboration


    These benefits come into play with every piece of technology that moves into
    as-Code; we have seen it time and again as DevOps processes mature and we
    automate each piece of the software development lifecycle. Here are the
    critical 'as-Code' stages: 


    ### Build-as-Code


    One of the first steps when building a new pipeline is to implement a way to
    build your application automatically. Containerization is one of the most
    common ways: You define your build steps as a Dockerfile and then you have
    automated the build of the application.


    ### Test-as-Code


    As our deployment frequency and team size scales, the need for test cases to
    be automated scales as well. So we automate, we write unit tests and test
    scripts to execute unit tests, and then we ensure the changes can be
    continuously integrated safely, without introducing unplanned bugs.


    ### Security-as-Code


    To ensure software gets to market quickly, security must be included in your
    testing process. The testing has to happen either through tools integrated
    with each individual project, or implemented as code, creating job templates
    for security scanners that can be ingested by projects as required. These
    steps enable teams to quickly become compliant with various security
    frameworks (like PCI-DSS, HIPAA,,or ISO) as they become relevant for the
    project.


    ### Deployment-as-Code


    Deployments need to be standardized so they are predictable every time. To
    ensure successful peer review, production and development environment
    deployments need to be the same, and there's an added bonus of a quality
    gate between them. Through scripting and implementation of
    Deployment-as-Code, we end up with the ability to continuously deploy code
    and continuously deliver value.


    ## Why Pipelines-as-Code?


    Pipelines are the center of the CI/CD workflow – they're the automation
    heart that powers all of the benefits of as-Code technologies. Once you have
    the Build-as-Code, Test-as-Code, Deployment-as-Code, Infrastructure-as-Code,
    and Configuration-as-Code, you have all the parts needed to ensure that you
    can reliably and predictably take your application into production
    environments. But, to move changes in with agility, you need to take all
    those parts and string them together into a pipeline.


    The technology behind Pipelines-as-Code makes it possible to create
    centralized repositories for your organization's pipelines.
    Pipelines-as-Code can be set up to fit all boxes for varied languages and
    use cases (like [Auto
    DevOps](https://docs.gitlab.com/ee/topics/autodevops/)) or with a [number of
    options](https://gitlab.com/gitlab-org/gitlab/-/tree/master/lib/gitlab/ci/templates)
    so that developers can pick base pipelines to fit their use case. It's
    important to have a baseline that conforms to the organization's standards
    because that always increases the speed to production.


    The entire team can collaborate on changes to each part of the workflow.
    Version history can be easily maintained in the same version control system
    as everything else that touches the DevOps lifecycle.


    The benefits of as-Code technology reach a pinnacle with Pipelines-as-Code,
    so teams gain increases in efficiency, scalability, auditability, and
    collaboration. Pipelines-as-Code are at the center of automated GitOps,
    DevOps, and SecOps workflows.
  category: Engineering
  tags:
    - AI/ML
    - cloud native
    - DevOps
config:
  slug: pipelines-as-code
  featured: false
  template: BlogPost
